package edu.bsu.cs.gui;

import edu.bsu.cs.algorithm.*;
import edu.bsu.cs.graph.*;

import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.Vector;
import java.util.zip.*;
import java.awt.*;
import java.util.*;
import javax.imageio.stream.*;

/*
 Commented by Sunita Upadrasta 14 Mar 2006 - Since these are not used in the current file.

 import java.math.*;
 import javax.swing.*;
 import javax.swing.event.*;
 import javax.swing.text.*;
 import java.applet.*;
 import java.lang.reflect.Array;
 */

/**
 * Creates and maintains the "controls" for Jedit - the JeditMenubar and
 * JeditToolbar.
 *
 * @author Elizabeth VandenBerg
 * @author Sunita Upadrasta
 * @since 24 May 2002
 * @version 16 May 2003
 */
public class JeditControls extends JPanel implements Serializable {

	/**
	* ****************************************************************************************************
	* ****************************************************************************************************
	* ****************************************************************************************************
	* ****************************************************************************************************
	* ****     NOTE:  PLEASE DO NOT CHANGE THE PLACE MARKS STARTING WITH \\CH				***************
	* ****     THEY DENOTE THE CHANGES TO BE MADE IN THE FILES TO INCLUDE A NEW ALGORITHM. ***************
	* ****************************************************************************************************
	* ****************************************************************************************************
	* ****************************************************************************************************
	* ****************************************************************************************************
	*/

	private static final long serialVersionUID = 1L;

	String lastFileName = JeditFrame.NEWFILENAME;// E. VandenBerg 2002-Jun-06

	String lastDirectory = JeditFrame.GRAPHDIRECTORY;// E. VandenBerg
														// 2002-Jun-06

	ButtonGroup bTBGroup = new ButtonGroup();// E. VandenBerg 2002-Jun-19

	ButtonGroup bMUGroup = new ButtonGroup();// E. VandenBerg 2002-Jun-19

	// NOTE: These button groups are basically going to operate for only
	// one set of mutually exclusive buttons; they will be used to set
	// buttons and menu items as selected/unselected together
	//

	/** The JeditPanel that the JeditControls are placed and operate on. */
	public JeditPanel panel;

	JeditFrame frame;

	/**
	 * The JeditResources that handles the jedit.properties document which
	 * contains information such as Text, Icon, ShortDescription for all of the
	 * menus, menu items, and toolbar buttons.
	 */
	public JeditResources rm = new JeditResources("jedit"); // E. VandenBerg
															// 2002-May-23

	/**
	 * Creates a new JeditControls panel and places it on newpanel.
	 *
	 * @param newpanel
	 *            The JeditPanel that the JeditControls is placed in.
	 */
	public JeditControls(JeditFrame newframe) {

		int rmax;
		String[] rarray;

		setLayout(new BorderLayout());

		frame = newframe;
		panel = frame.getPanel();

		// Menu Bar
		JeditMenubar jemb = new JeditMenubar();
		add(jemb, BorderLayout.NORTH);// E. VandenBerg 2002-Jun-17

		// Tool Bars
		rmax = 4 + 1;
		rarray = new String[rmax];
		rarray[1] = "FileNew";
		rarray[2] = "FileNewAlgorithm";
		rarray[3] = "FileOpen";
		rarray[4] = "FileSave";
		JeditToolbar jetb0 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "File");

		rmax = 3 + 1;
		rarray = new String[rmax];
		rarray[1] = "EditClear";
		rarray[2] = "EditUndo";
		rarray[3] = "EditPreferences";
		JeditToolbar jetb1 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "Edit");

		rmax = 4 + 1;
		rarray = new String[rmax];
		rarray[1] = "GraphMoveObject";
		rarray[2] = "GraphAddVertex";
		rarray[3] = "GraphAddEdge";
		rarray[4] = "GraphAddArc";
		JeditToolbar jetb2 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "Graph Tools");

		rmax = 3 + 1;
		rarray = new String[rmax];
		rarray[1] = "GraphArrange";
		rarray[2] = "GraphRotate";
		rarray[3] = "GraphResize";
		JeditToolbar jetb7 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "Format");

		rmax = 6 + 1;
		rarray = new String[rmax];
		rarray[1] = "GraphAddSpecial1";
		rarray[2] = "GraphAddSpecial2";
		rarray[3] = "GraphAddSpecial3";
		rarray[4] = "GraphAddSpecial4";
		rarray[5] = "GraphAddSpecial5";
		rarray[6] = "GraphInsertImage";
		// rarray[6] = "Algorithm27";
		JeditToolbar jetb3 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "Insert");

		rmax = 2 + 1;
		rarray = new String[rmax];
		rarray[1] = "GraphComplete";
		rarray[2] = "GraphComplement";
		// rarray[3] = "AlgorithmSelect";
		JeditToolbar jetb4 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "Operations");

		rmax = 2 + 1;
		rarray = new String[rmax];
		rarray[1] = "FileEncode";
		rarray[2] = "GraphClone";
		JeditToolbar jetb5 = new JeditToolbar(panel, rarray,
				JToolBar.HORIZONTAL, "Misc");

		// E. VandenBerg 2002-Jun-13 temporary until I implement the
		// ability to customize the toolbar
		// *************************************
		// *************************************
		// ************************************* Make Change 1 below, increment
		// rmax = x + 1 to (x+1) + 1
		// *************************************

		String rname = "AlgorithmMenu";
		// CH1
        rmax = 25 + 1;
		rarray = new String[rmax];
		rarray[1] = "Algorithm1";
		rarray[2] = "Algorithm2";
		rarray[3] = "Algorithm3";
		rarray[4] = "Algorithm4";
		rarray[5] = "Algorithm5";
		rarray[6] = "Algorithm6";
		rarray[7] = "Algorithm7";
		rarray[8] = "Algorithm8";
		rarray[9] = "Algorithm9";
		rarray[10] = "Algorithm10";
		rarray[11] = "Algorithm11";
		rarray[12] = "Algorithm12";
		rarray[13] = "Algorithm13";
		rarray[14] = "Algorithm14";
		rarray[15] = "Algorithm15";
		rarray[16] = "Algorithm16";
		rarray[17] = "Algorithm17";
		rarray[18] = "Algorithm18";
		rarray[19] = "Algorithm19";
		rarray[20] = "Algorithm20";
		rarray[21] = "Algorithm21";
		rarray[22] = "Algorithm22";
		rarray[23] = "Algorithm23";
		rarray[24] = "Algorithm24";
        rarray[25] = "Algorithm25";
        // CH2
		// *************************************
		// *************************************
		// ************************************* Make Change 2 above, add line
		// rarray[x+1] = ...
		// *************************************

		JeditMenu tempmenu = new JeditMenu(rname, rarray, rmax);
		JToolBar t = new JToolBar(rm.getText(rname));
		t.add(tempmenu);
		JPanel tp = new JPanel();
		tp.add(t);

		JPanel tempPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		tempPanel.add(jetb0);
		tempPanel.add(jetb1);
		tempPanel.add(jetb2);
		tempPanel.add(jetb7);
		tempPanel.add(jetb3);
		tempPanel.add(jetb4);
		// tempPanel.add(tp);
		tempPanel.add(jetb5);
		tempPanel.setAlignmentX(LEFT_ALIGNMENT);
		add(tempPanel, BorderLayout.CENTER);

		setAlignmentX(LEFT_ALIGNMENT);
		setVisible(true);

	}

	// ************************************************************************
	/**
	 * The Toolbar that a user of Jedit uses to indicate what action should be
	 * taken next.
	 *
	 * @author Aaron Nall
	 * @author Vellanki Kiran
	 * @author Elizabeth VandenBerg
	 * @since 01 Jul 1998
	 * @version 06 Jun 2002
	 * @see JPanel
	 */
	public class JeditToolbar extends JPanel implements ActionListener,
			Serializable {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		private JToolBar t;

		/**
		 * Default constructor.
		 */
		public JeditToolbar() {
			super();

			t = new JToolBar();

			setLayout(new BorderLayout());
			add(t, BorderLayout.NORTH);
			setVisible(true);
		}

		/**
		 * Creates a new JeditToolbar with the following properties.
		 *
		 * @param newPanel
		 *            The <a href = JeditPanel.html>JeditPanel</a> that the
		 *            user will be using the JeditToolbar to edit.
		 * @param rarray
		 *            The array of JeditResources keys - toolbar data obtained
		 *            from jedit.properties document using these keys.
		 * @param orientation
		 *            JToolBar.HORIZONTAL or JToolBar.VERTICAL.
		 * @param title
		 *            The title of the toolbar when it is detached.
		 */
		public JeditToolbar(JeditPanel newPanel, String[] rarray,
				int orientation, String title) {
			super();

			t = new JToolBar();

			setPanel(newPanel);
			setButtons(rarray);
			setOrientation(orientation);
			setTitle(title);

			setLayout(new BorderLayout());
			add(t, BorderLayout.NORTH);
			setVisible(true);

		}

		public void setPanel(JeditPanel newPanel) {
			panel = newPanel;
		}

		public void setOrientation(int orientation) {
			t.setOrientation(orientation);

		}

		public void setTitle(String title) {
			t.setName(title);
		}

		// E. VandenBerg 2002-Jun-05
		public void setButtons(String[] rarray) {

			int rmax;
			JeditAction tempaction;

			String rname, isToggle, isSelected;

			GridLayout gl = new GridLayout(1, 0);
			// FlowLayout gl = new FlowLayout();
			JPanel tPanel = new JPanel();
			// BoxLayout gl = new BoxLayout(tPanel,BoxLayout.X_AXIS);
			tPanel = new JPanel(gl);

			rmax = rarray.length;

			// ***********************************
			// *************************************
			// ************************************* Make Change 3 below :
			// change Dimension(x,x) to Dimension(x+1,x+1)
			// *************************************

			// CH3
            Dimension dim = new Dimension(25, 25);
			for (int i = 1; i < rmax; i++) {
				rname = rarray[i];
				if (rname != null) {
					if ((rname.equals("--"))
							|| (rm.getText(rname).equals("--")))
						t.addSeparator();
					else {
						tempaction = new JeditAction(rname);
						isToggle = tempaction.getValue("IS_TOGGLE").toString();
						isSelected = tempaction.getValue("IS_SELECTED")
								.toString();
						if (isToggle.equals("yes")) {
							// //System.out.println("Radio Button :
							// "+rm.getText(rname));
							JToggleButton temptbutton;
							temptbutton = new JToggleButton(tempaction);
							if (isSelected.equals("yes"))
								temptbutton.setSelected(true);
							else
								temptbutton.setSelected(false);
							rm.prettifyButton(temptbutton, rname);
							temptbutton.setText(null);
							temptbutton.setMaximumSize(dim);
							temptbutton.setMinimumSize(dim);
							temptbutton.setPreferredSize(dim);
							temptbutton.addActionListener(this);
							tPanel.add(temptbutton);
							bTBGroup.add(temptbutton);
						} else {
							JButton tempbutton = new JButton(tempaction);
							rm.prettifyButton(tempbutton, rname);
							t.add(tempaction);
						}
					}
				}
			}
			if (bTBGroup.getButtonCount() > 0) {
				// E. VandenBerg 2002-Jun-16
				t.add(tPanel); // E. VandenBerg 2002-Jun-16
			}
		}

		public void actionPerformed(ActionEvent e) {
			Enumeration enM = bMUGroup.getElements();
			for (Enumeration enT = bTBGroup.getElements(); enT
					.hasMoreElements();) {
				boolean sel = ((JToggleButton) (enT.nextElement()))
						.isSelected();
				((JRadioButtonMenuItem) (enM.nextElement())).setSelected(sel);
			}
		}

	} // public class JeditToolbar
	// ************************************************************************

	// ************************************************************************
	/**
	 * A Menu that a user of Jedit uses to indicate what action should be taken
	 * next.
	 *
	 * @author Elizabeth VandenBerg
	 * @since 16 Jun 2002
	 * @version 16 Jun 2002
	 */
	public class JeditMenu extends JMenu implements ActionListener,
			Serializable {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		/**
		 * Default constructor.
		 */
		public JeditMenu() {
			super();
		}

		/**
		 * Creates a new JMenu with the following properties.
		 *
		 * @param newPanel
		 *            The <a href = JeditPanel.html>JeditPanel</a> that the
		 *            user will be using the JeditToolbar to edit.
		 * @param rarray
		 *            The array of JeditResources keys - toolbar data obtained
		 *            from jedit.properties document using these keys.
		 */
		public JeditMenu(String rname, String[] rarray, int rmax) {
			super();
			setText(rm.getText(rname));
			setToolTipText(rm.getShortDescription(rname));
			setMnemonic(rm.getMnemonicKey(rname).intValue());
			buildItem(rname, rarray, rmax);
		}

		void buildItem(String rname, String[] rarray, int rmax) {

			JMenuItem tempitem, tempsitem;
			JMenu tempitemm;
			JeditAction tempaction, tempsaction;
			Integer rsmax, tempj;
			String isSubmenu, isSelected, isToggle;
			// Object[] actionkeys; // Sunita Upadrasta 14 Mar 2006 - Since it
			// is not used locally.
			String rsname;

			for (int i = 1; i < rmax; i++) {
				rname = rarray[i];
				if (rname != null) {// E. VandenBerg 2002-Jun-06
					if ((rname.equals("--"))
							|| (rm.getText(rname).equals("--")))
						addSeparator();
					else {
						tempaction = new JeditAction(rname);

						isSubmenu = tempaction.getValue("IS_SUBMENU")
								.toString();
						isToggle = tempaction.getValue("IS_TOGGLE").toString();
						isSelected = tempaction.getValue("IS_SELECTED")
								.toString();// E. VandenBerg 2002-Jun-16
						// //System.out.println("Line 136 - isSubmenu =
						// "+isSubmenu);

						if (isSubmenu.equals("yes")) {
							// //System.out.println("Is Submenu -- "+rname);
							tempitemm = new JMenu(tempaction);

							// Submenu part***************************
							rsmax = new Integer(rm.getText(rname + "Max"));
							for (int j = 1; j <= rsmax.intValue(); j++) {
								tempj = new Integer(j);
								rsname = rname + tempj.toString();
								// //System.out.println("Submenu -- "+rsname);
								if ((rsname.equals("--"))
										|| (rm.getText(rsname).equals("--")))
									tempitemm.addSeparator();
								else {
									tempsaction = new JeditAction(rsname);
									tempsitem = new JMenuItem(tempsaction);
									rm.prettifyMenuItem(tempsitem, rsname);
									tempitemm.add(tempsitem);// tempsaction);
								}
							}
							// ***************************************

							rm.prettifyMenuItem(tempitemm, rname);
							tempitemm.addActionListener(this);
							add(tempitemm);
						} else {
							if (isToggle.equals("yes")) {
								JRadioButtonMenuItem temptitem = new JRadioButtonMenuItem(
										tempaction);// E. VandenBerg 2002-Jun-16

								if (isSelected.equals("yes"))// E. VandenBerg
																// 2002-Jun-16
									temptitem.setSelected(true);// E. VandenBerg
																// 2002-Jun-16
								else
									// E. VandenBerg 2002-Jun-16
									temptitem.setSelected(false);// E.
																	// VandenBerg
																	// 2002-Jun-16

								rm.prettifyMenuItem(temptitem, rname);// E.
																		// VandenBerg
																		// 2002-Jun-16
								bMUGroup.add(temptitem);// E. VandenBerg
														// 2002-Jun-16
								temptitem.addActionListener(this);
								add(temptitem);// tempaction);
							} else {
								tempitem = new JMenuItem(tempaction);
								rm.prettifyMenuItem(tempitem, rname);
								tempitem.addActionListener(this);
								add(tempitem);// tempaction);
							}

						}

					}
				}
			}

		}

		/**
		 */
		public void actionPerformed(ActionEvent e) {
			Enumeration enT = bTBGroup.getElements();
			for (Enumeration enM = bMUGroup.getElements(); enM
					.hasMoreElements();) {
				boolean sel = ((JRadioButtonMenuItem) (enM.nextElement()))
						.isSelected();
				((JToggleButton) (enT.nextElement())).setSelected(sel);
			}

		}

	} // public class JeditMenu
	// ************************************************************************

	// ************************************************************************
	/**
	 * The menubar for Jedit.
	 *
	 * @author Unknown originator
	 * @author Elizabeth VandenBerg
	 * @since Unknown
	 * @version 24 May 2002
	 * @see JPanel
	 */
	public class JeditMenubar extends JMenuBar implements Serializable {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		/**
		 * Constructor.
		 *
		 * @param newpanel
		 *            The JeditPanel to place the JeditMenubar on.
		 */
		public JeditMenubar() {

			super();

			String rname;
			String rarray[];

			int rmax;
			// int rsint; // Sunita Upadrasta 14 Mar 2006 - Since it is not used
			// locally.
			JeditMenu tempmenu; // E. VandenBerg 2002-May-23

			// setSize(520,400);

			// *************************** FILE MENU
			// ********************************
			// E. VandenBerg - 2002-May-24
			// **********************************************************************
			rname = "FileMenu";
			rmax = 16 + 1;
			rarray = new String[rmax];
			rarray[1] = "FileNew";
			rarray[2] = "FileNewAlgorithm";
			rarray[3] = "FileOpen";
			rarray[4] = "FileClose";
			rarray[5] = "FileCloseAll";
			rarray[6] = "--";
			rarray[7] = "FileSave";
			rarray[8] = "FileSaveAs";
			rarray[9] = "FileSaveAll";
			rarray[10] = "FileEncode";
			rarray[11] = "FileRevert";
			rarray[12] = "--";
			rarray[13] = "FilePageSetup";
			rarray[14] = "FilePrint";
			rarray[15] = "--";
			rarray[16] = "FileExit";
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// *************************** EDIT MENU
			// ********************************
			// E. VandenBerg - 2002-May-24
			// **********************************************************************
			rname = "EditMenu";
			rmax = 12 + 1;
			rarray = new String[rmax];
			rarray[1] = "EditUndo";
			rarray[2] = "--";
			rarray[3] = "EditCut";
			rarray[4] = "EditCopy";
			rarray[5] = "EditPaste";
			rarray[6] = "--";
			rarray[7] = "EditDuplicate";
			rarray[8] = "EditClear";
			rarray[9] = "--";
			rarray[10] = "EditSelectAll";
			rarray[11] = "--";
			rarray[12] = "EditPreferences";
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// ************************* INSERT MENU
			// ********************************
			// E. VandenBerg - 2002-Jun-13
			// **********************************************************************
			rname = "InsertMenu";
			rmax = 3 + 1;
			rarray = new String[rmax];
			rarray[1] = "GraphAddSpecial";
            //rarray[2] = "--";
            //rarray[3] = "GraphInsertImage";
            // rarray[2] = "GraphAddSpecial2";
			// rarray[3] = "GraphAddSpecial3";
			// rarray[4] = "GraphAddSpecial4";
			// rarray[5] = "GraphAddSpecial5";
			// rarray[2] = "Algorithm27";
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// ************************* FORMAT MENU
			// ********************************
			// E. VandenBerg - 2002-Jun-13
			// **********************************************************************
			rname = "FormatMenu";
			rmax = 8 + 1;
			rarray = new String[rmax];
			rarray[1] = "GraphMoveObject";
			rarray[2] = "GraphAddVertex";
			rarray[3] = "GraphAddEdge";
			rarray[4] = "GraphAddArc";
			rarray[5] = "--";
			rarray[6] = "GraphArrange";
			rarray[7] = "GraphRotate";
			rarray[8] = "GraphResize"; // E. VandenBerg 2002-Sep-23
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// *************************** GRAPH MENU
			// *******************************
			// E. VandenBerg - 2002-May-24
			// **********************************************************************
			rname = "GraphMenu";
			rmax = 4 + 1;
			rarray = new String[rmax];
			rarray[1] = "GraphAdjacencyMatrix";
			rarray[2] = "--";
			rarray[3] = "GraphComplement";
			rarray[4] = "GraphComplete";
			// rarray[3] = "--";
			// rarray[4] = "GraphDeleteAllEdges";
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// ************************ ALGORITHM MENU
			// ******************************
			// E. VandenBerg - 2002-May-24
			// **********************************************************************
			// ***********************************
			// *************************************
			// ************************************* Make Change 4 below :
			// change rmax = x+1 to rmax = (x+1) + 1
			// *************************************
			rname = "AlgorithmMenu";
			// CH4
            rmax = 28 + 1;
			rarray = new String[rmax];
			rarray[1] = "AlgorithmSelect";
			rarray[2] = "AlgorithmDelete";
			rarray[3] = "--";
			rarray[4] = "Algorithm1";
			rarray[5] = "Algorithm2";
			rarray[6] = "Algorithm3";
			rarray[7] = "Algorithm4";
			rarray[8] = "Algorithm5";
			rarray[9] = "Algorithm6";
			rarray[10] = "Algorithm7";
			rarray[11] = "Algorithm8";
			rarray[12] = "Algorithm9";
			rarray[13] = "Algorithm10";
			rarray[14] = "Algorithm11";
			rarray[15] = "Algorithm12";
			rarray[16] = "Algorithm13";
			rarray[17] = "Algorithm14";
			rarray[18] = "Algorithm15";
			rarray[19] = "Algorithm16";
			rarray[20] = "Algorithm17";
			rarray[21] = "Algorithm18";
			rarray[22] = "Algorithm19";
			rarray[23] = "Algorithm20";
			rarray[24] = "Algorithm21";
			rarray[25] = "Algorithm22";
			rarray[26] = "Algorithm23";
			rarray[27] = "Algorithm24";
            rarray[28] = "Algorithm25";
        // CH5

			// ***********************************
			// *************************************
			// ************************************* Make Change 5 above Add
			// line rarray[x+1]= Algorithm[x-1]
			// *************************************
			// ***********************************
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// *************************** WINDOW MENU
			// ******************************
			// E. VandenBerg - 2002-May-24
			// **********************************************************************
			rname = "WindowMenu";
			rmax = 6 + 1;
			rarray = new String[rmax];
			rarray[1] = "FileNew";
			rarray[2] = "GraphClone";
			rarray[3] = "--";
			rarray[4] = "WindowTileH";
			rarray[5] = "WindowTileV";
			rarray[6] = "WindowCascade";
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			// **************************** HELP MENU
			// *******************************
			// E. VandenBerg - 2002-May-24
			// **********************************************************************
			rname = "HelpMenu";
			rmax = 4 + 1;
			rarray = new String[rmax];
			rarray[1] = "HelpIntroduction";
			rarray[2] = "HelpContents";
			rarray[3] = "--";
			rarray[4] = "HelpAbout";
			tempmenu = new JeditMenu(rname, rarray, rmax);
			add(tempmenu);
			// **********************************************************************
			// **********************************************************************
			// **********************************************************************

			setAlignmentX(LEFT_ALIGNMENT);
			// setLayout(new BorderLayout());
			// add(tempmenubar,BorderLayout.NORTH);

		} // JmenuBar constructor

	}

	/**
	 * Contains and maintains all of the Actions for the JeditControls.
	 *
	 * @author Elizabeth VandenBerg
	 * @since 24 May 2002
	 * @version 25 May 2002
	 */
	public class JeditAction extends AbstractAction implements Serializable {
		// These actions use to be maintained in both the JeditMenubar and
		// JeditToolbar
		// classes, which didn't make sense because it was duplicating code and
		// opening
		// it up for inconsistencies.

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		/**
		 * Creates a new JeditAction of name text.
		 *
		 * @param text
		 *            This is the JeditResources key, not the text of the menu,
		 *            menu item or toolbar button. The keys are maintained in
		 *            the jedit.properties document.
		 * @see JeditResources
		 */
		public JeditAction(String text) {
			super(rm.getText(text));
			rm.prettifyAction(this, text);
		}

		/**
		 * Implements all actions.
		 *
		 * @param ae
		 *            The ActionEvent.
		 */
		public void actionPerformed(ActionEvent ae) {

			int m, n;
			String inputValue;
			JavaGraph graph;

			// frame = (JeditFrame)(panel.getTopLevelAncestor());

			String s = (String) getValue(Action.DEFAULT);

			// System.out.println("s = "+s);
			frame.getMessagePane().append("");

			try {
				if (s.equals("FileNew")) {
					JeditFrame tempFrame = new JeditFrame(JeditFrame.baseTitle
							+ " - " + JeditFrame.NEWFILENAME, frame.getApplet());
					// tempFrame.setSize(frame.getSize());
					tempFrame.setLocation(frame.getLocation().x + 20, frame
							.getLocation().y + 20);
					panel.repaint(); // Clean up the display
				}// New

				// Sunita Upadrasta 2005-Nov-24 inserted to include a new menu
				// item.
				if (s.equals("FileNewAlgorithm")) {
					new JEditNewAlg(frame);
					// frame.dispose(); // Sunita Upadrasta 2006-Mar-21 Original
					// screen is not closed after creating or cancelling.
				}// New

				if (s.equals("FileNewSpecial")) {
				}// New Special...

				if (s.equals("FileNewSpecial1")) {
				}// Heawood
				if (s.equals("FileNewSpecial2")) {
				}// Hypercube
				if (s.equals("FileNewSpecial3")) {
				}// Kmn
				if (s.equals("FileNewSpecial4")) {
				}// Kn
				if (s.equals("FileNewSpecial5")) {
				}// Petersen

				if (s.equals("FileOpen")) {
					System.out.println("FileOpen");
					JavaGraph tempGraph = graphOpen(lastDirectory, ""); // E.
																		// VandenBerg
																		// 2002-Jun-06
																		// moved
																		// to
																		// method
					if (tempGraph != null) {
						panel.setGraph(tempGraph);
						panel.repaint();
					}
				}

				if (s.equals("FileClose")) {
					frame.dispose();// E. VandenBerg 2002-Jun-20
				}// Close

				if (s.equals("FileSave")) {
					System.out.println("FileSave");
					if (lastFileName.equals(JeditFrame.NEWFILENAME)) {
						graphSaveAs(panel.getGraph(), lastDirectory,
								lastFileName);// E. VandenBerg 2002-Jun-06
												// moved to method
					} else {
						graphSave(panel.getGraph(), lastDirectory, lastFileName);
						// E. VandenBerg 2002-Jun-06 moved to method
					}// end of if-else
					panel.repaint();// E. VandenBerg 2002-Jun-13
				}// end of "Save" added by Adrian Heinz modified from Dr.
					// Bagga's "Save as"

				if (s.equals("FileSaveAs")) {
					System.out.println("FileSaveAs");
					graphSaveAs(panel.getGraph(), lastDirectory, lastFileName);
                    // E. VandenBerg 2002-Jun-06 moved to method
					panel.repaint();// E. VandenBerg 2002-Jun-13
				}// end of "Save as"

				if (s.equals("FileSaveAll")) {
				}// Save All

				if (s.equals("FileEncode")) {// Encode
					try {
						new PrintGraph(frame).printGraph();
					} catch (Exception ex) {
						;
					}
				}

				if (s.equals("FileRevert")) {
				}// Revert
				if (s.equals("FilePageSetup")) {
				}// Page Setup...
				if (s.equals("FilePrint")) {
				}// Print...

				if (s.equals("FileExit")) {
					frame.dispose();// E. VandenBerg 2002-Sep-19
					// NEED TO MAKE THE ENTIRE APP EXIT HERE
				} // added by Jay, July 17,2000

				if (s.equals("EditUndo")) {
					panel.restoreBackup();
					panel.setMouseAction(JeditPanel.NOTHING);
				}

				if (s.equals("EditCut")) {
				}// Cut
				if (s.equals("EditCopy")) {
				}// Copy
				if (s.equals("EditPaste")) {
				}// Paste
				if (s.equals("EditDuplicate")) {
				}// Duplicate
				if (s.equals("EditClear")) // Clear
				{
					Vector message = new Vector();
					message
							.addElement(new String(
									"You are about to delete the"));
					message.addElement(new String(
							"entire graph. Are you certain"));
					message.addElement(new String("you want to proceed?"));
					YesNo question = new YesNo("Warning", "Yes", "No", message,
							panel, YesNo.CLEAR);
					question.setVisible(true);
					panel.setEnable(false);
					panel.setMouseAction(JeditPanel.NOTHING);
				}

				if (s.equals("EditSelectAll")) {
				}// Select All

				if (s.equals("EditPreferences")) // Preferences...
				{
					new JeditPrefs(frame);
					panel.setMouseAction(JeditPanel.NOTHING);
				}

				if (s.equals("GraphAddVertex")) {
					panel.setMouseAction(JeditPanel.ADDVERTEX);
				}

				if (s.equals("GraphAddEdge")) {
					panel.setMouseAction(JeditPanel.ADDEDGE);
				}

				if (s.equals("GraphAddArc")) {
					panel.setMouseAction(JeditPanel.ADDARC);
				}

				if (s.equals("GraphMoveObject")) {
					panel.setMouseAction(JeditPanel.MOVETHINGS);
				}

				if (s.equals("GraphClone")) // Clone
				{
					new JeditFrame(frame, true);
					panel.setMouseAction(JeditPanel.NOTHING);
				}

				if (s.equals("GraphArrange")) // Arrange...
				{
					try {
						new JeditArrange(frame);
						panel.setMouseAction(JeditPanel.NOTHING);
					} catch (Exception ex) {
						;
					}
				}

				if (s.equals("GraphAdjacencyMatrix")) {// E. VandenBerg
														// 2002-Jul-15
					System.out.println("Adjacency matrix");
					// panel.getGraph().printAdjacencyMatrix();//E. VandenBerg
					// 2002-Jul-15
				}// E. VandenBerg 2002-Jul-15

				if (s.equals("GraphComplement")) {// Complement
					try {
						panel.backup();
						for (int k = panel.getGraph().order() - 1; k >= 0; k--)
							for (int j = panel.getGraph().order() - 1; j >= 0; j--) {
								if (j != k)
									if (!panel.getGraph().removeEdge(j, k)) {
										panel.getGraph().addEdge(j, k);
										panel.getGraph().setEdgeColor(j, k,
												panel.getEdgeColor());
									}
							}
						panel.autoLabelAllEdges();
						panel.repaint();
						panel.setMouseAction(JeditPanel.NOTHING);
					} catch (Exception ex) {
						;
					}
				}

				if (s.equals("GraphComplete")) {
					try {
						panel.backup();
						for (int k = panel.getGraph().order() - 1; k >= 0; k--)
							for (int j = panel.getGraph().order() - 1; j >= 0; j--)
								if (j != k)
									if (!panel.getGraph().removeEdge(j, k)) {
										panel.getGraph().addEdge(j, k);
										panel.getGraph().setEdgeColor(j, k,
												panel.getEdgeColor());
									} else {
										panel.getGraph().addEdge(j, k);
										panel.getGraph().setEdgeColor(j, k,
												panel.getEdgeColor());
									}
						panel.autoLabelAllEdges();
						panel.repaint();
						panel.setMouseAction(JeditPanel.NOTHING);

					} catch (Exception ex) {
						;
					}
				}

				if (s.equals("GraphRotate")) {// Rotate
					try {
						new Rotation("Enter the rotation angle", panel);
						panel.setMouseAction(JeditPanel.NOTHING);
					} catch (Exception ex) {
						;
					}
				}

				if (s.equals("GraphResize")) // Resize...
				{
					try {
						new Resize(frame);
					} catch (Exception ex) {
						;
					}
				}

				if (s.equals("GraphAddSpecial")) {
				}// Add Famous Graph

				if (s.equals("GraphAddSpecial4")) // Heawood
				{
					Heawood myHeawood = new Heawood();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myHeawood.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}

				if (s.equals("GraphAddSpecial5")) { // Hypercube
					inputValue = JOptionPane
							.showInputDialog("Please input the value of n (0<=n<=4)");
					try {
						n = Integer.parseInt(inputValue);
						if ((n < 0) || (n > 4))
							throw new NumberFormatException();
					} catch (NumberFormatException k) {
						JOptionPane.showMessageDialog(null,
								"Input an integer between 0 and 4.",
								"Value of n", JOptionPane.ERROR_MESSAGE);
						return;
					}
					Hypercube myHypercube = new Hypercube(n);
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myHypercube
							.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}

				if (s.equals("GraphAddSpecial2")) {// Kmn

					inputValue = JOptionPane
							.showInputDialog("Please input the value of m (>0)");
					try {
						m = Integer.parseInt(inputValue);
						if (m < 1)
							throw new NumberFormatException();
					} catch (NumberFormatException k) {
						JOptionPane.showMessageDialog(null,
								"Not valid value entered", "Value of m",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					inputValue = JOptionPane
							.showInputDialog("Please input the value of n (>0)");
					try {
						n = Integer.parseInt(inputValue);
						if (n < 1)
							throw new NumberFormatException();
					} catch (NumberFormatException k) {
						JOptionPane.showMessageDialog(null,
								"Not valid value entered", "Value of n",
								JOptionPane.ERROR_MESSAGE);
						return;
					}

					Kmn myKmn = new Kmn(m, n);

					panel.setDelay(true); // E. VandenBerg 2003-Jan-21
					panel.setAlgorithm(myKmn); // E. VandenBerg 2003-Jan-21
					panel
							.setBackgroundColor(JeditFrame.DEFAULT_BACKGROUND_COLOR);// E.
																						// VandenBerg
																						// 2003-Jan-23
					panel.setLabelColor(JeditFrame.DEFAULT_BACKGROUND_COLOR);// E.
																				// VandenBerg
																				// 2003-Jan-23

					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myKmn.callOwnConstructor(graph, null, animationVector);

					if (myKmn.succeeded()) { // E. VandenBerg 2003-Jan-21
						Animation animate = new Animation(animationVector,
								panel, true); // E. VandenBerg 2003-Jan-21
						animate.start(); // E. VandenBerg 2003-Jan-21
						// do {
						// System.out.println("Waiting...");
						// } while (!animate.isAlive());
						// panel.setLabelColor(JeditFrame.DEFAULT_LABEL_COLOR);//E.
						// VandenBerg 2003-Jan-23
					} // E. VandenBerg 2003-Jan-21

					panel.setLabelColor(JeditFrame.DEFAULT_LABEL_COLOR);
					// Sunita Upadrasta 2006-Jan-26 To change the color of the labels to black after animation.
					panel.repaint(); // E. VandenBerg 2003-Jan-21
					panel.setEnable(false); // E. VandenBerg 2003-Jan-21

					// panel.repaint();
				}

				if (s.equals("GraphAddSpecial1")) {// Kn
					inputValue = JOptionPane
							.showInputDialog("Please input the value of n (>0)");
					try {
						n = Integer.parseInt(inputValue);
						if (n < 1)
							throw new NumberFormatException();
					} catch (NumberFormatException k) {
						JOptionPane.showMessageDialog(null,
								"Not valid value entered", "Value of n",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					Kn myKn = new Kn(n);
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myKn.callOwnConstructor(graph, null, animationVector);
					panel.autoLabelAllEdges();
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial17")) {// Wheel
					inputValue = JOptionPane
							.showInputDialog("Please input the value of n (0>n<25)");
					try {
						n = Integer.parseInt(inputValue);
						if (n < 1 || n > 25)
							throw new NumberFormatException();
					} catch (NumberFormatException k) {
						JOptionPane.showMessageDialog(null,
								"Not valid value entered", "Value of n",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					Wheel myWheel = new Wheel(n);
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myWheel.callOwnConstructor(graph, null, animationVector);
					panel.autoLabelAllEdges();
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial18")) {// Cycle
					inputValue = JOptionPane
							.showInputDialog("Please input the value of n (0>n<25)");
					try {
						n = Integer.parseInt(inputValue);
						if (n < 1 || n > 25)
							throw new NumberFormatException();
					} catch (NumberFormatException k) {
						JOptionPane.showMessageDialog(null,
								"Not valid value entered", "Value of n",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					Cycle myCycle = new Cycle(n);
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myCycle.callOwnConstructor(graph, null, animationVector);
					panel.autoLabelAllEdges();
					panel.repaint();
				}

				if (s.equals("GraphAddSpecial3")) {// Petersen
					Petersen myPetersen = new Petersen();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myPetersen.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial6")) {// Chvatal
					Chvatal myChvatal = new Chvatal();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myChvatal.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial7")) {// Franklin
					Franklin myFranklin = new Franklin();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myFranklin.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial9")) {// Tietze
					Tietze myTietze = new Tietze();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myTietze.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial8")) {// Folkman
					Folkman myFolkman = new Folkman();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myFolkman.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial10")) {// McGee
					McGee myMcGee = new McGee();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myMcGee.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial11")) {// Cube
					Cube myCube = new Cube();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myCube.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial12")) {// Icosahedron
					Icosahedron myIcosahedron = new Icosahedron();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myIcosahedron.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial13")) {// Octahedron
					Octahedron myOctahedron = new Octahedron();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myOctahedron.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial14")) {// Dodecahedron
					Dodecahedron myDodecahedron = new Dodecahedron();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myDodecahedron.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial15")) {// Tetrahedron
					Tetrahedron myTetrahedron = new Tetrahedron();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myTetrahedron.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}
//Rafi -- Apr-26-2006

				if (s.equals("GraphAddSpecial16")) {// Tutte-Coxetter
					Tutte_Coxetter myTutte_Coxetter = new Tutte_Coxetter();
					graph = panel.getGraph();
					Vector animationVector = new Vector();
					panel.backup();
					myTutte_Coxetter.callOwnConstructor(graph, null, animationVector);
					panel.repaint();
				}

				// Sunita Upadrasta 21-Apr-2006 Added to insert an image as background.
/*                if (s.equals("GraphInsertImage")) // Insert Image
                {
                    Image tempImage = imageOpen(lastDirectory, "");
                    if (tempImage != null) {
                        panel.setImage(tempImage);
                        panel.repaint();
                    }
                }
*/
				if (s.equals("GraphDeleteAllEdges")) {
				}// Delete all edges

				if (s.equals("AlgorithmSelect")) {// Select...
					new JeditAlgorithms(frame);// (JeditFrame)(panel.getTopLevelAncestor()));
				}

				// Sunita Upadrasta 2006-Mar-14 inserted to include a new menu
				// item to remove an algorithm.
				else if (s.equals("AlgorithmDelete")) {
					new JEditRemoveAlg(frame);
					// frame.dispose(); // Sunita Upadrasta 2006-Mar-21 Original
					// screen is not closed after removing an algorithm or if
					// cancel is pressed.
				} else if (s.startsWith("Algorithm")) {// an algorithm
				// System.out.println("Selected an algorithm.");
					Integer algmax = new Integer(rm
							.getText("AlgorithmSelectMax"));
					// System.out.println("algmax = "+algmax.toString());

					JeditAlgorithms algwin = new JeditAlgorithms(frame, false);// (JeditFrame)(panel.getTopLevelAncestor()),false);
					// System.out.println("algwin.algorithmVector.size()="+(new
					// Integer(algwin.algorithmVector.size()).toString()));

					for (int i = 1; i <= algmax.intValue(); i++) {
						Integer tempi = new Integer(i);
						// //System.out.println("i = "+tempi.toString());
						if (s.equals("Algorithm" + tempi.toString())) {
							// System.out.println("i = "+tempi.toString()+"
							// FOUND");

							// find the algorithm we want using the CODE in the
							// resource manager - which is
							// set as the Class name of the Algorithm
							String sc = (String) getValue("CODE");
							// System.out.println("sc = "+sc);
							int loc = -1;
							for (int w = 0; w < algwin.algorithmVector.size(); w++) {
								// System.out.println("w = "+tempw.toString());
								// System.out.println("code =
								// "+((Algorithm)(algwin.algorithmVector.elementAt(w))).getCode());
								if (sc
										.equals(((Algorithm) (algwin.algorithmVector
												.elementAt(w))).getCode())) {
									loc = w;
								}
							}

							if (loc > -1) {
								// //System.out.println("+++++++++");
								// System.out.println("code =
								// "+((Algorithm)(algwin.algorithmVector.elementAt(loc))).getCode());

								// frame.getMessagePane().append("***********************************************************\n");//E.
								// VandenBerg 2002-Jun-21
								// frame.getMessagePane().append("Starting " +
								// ((Algorithm)(algwin.algorithmVector.elementAt(loc))).getName()
								// + " Algorithm.\n");//E. VandenBerg
								// 2002-Jun-21

								panel.setDelay(true);// E. VandenBerg
														// 2002-Jun-21

								panel
										.setAlgorithm((Algorithm) (algwin.algorithmVector
												.elementAt(loc)));
								// //System.out.println("Algorithm =
								// "+(Algorithm)(algwin.algorithmVector.elementAt(loc)).toString());
								panel
										.setMouseAction(((Algorithm) (algwin.algorithmVector
												.elementAt(loc))).getType());
								// //System.out.println("Mouse Action =
								// "+((Algorithm)(algwin.algorithmVector.elementAt(loc))).getType().toString());

								panel.getGraph().unmarkAllVertices();// E.
																		// VandenBerg
																		// 2002-Jun-21
								panel.getGraph().unmarkAllEdges();// E.
																	// VandenBerg
																	// 2002-Jun-21

								switch (panel.getMouseAction()) {
								case JeditPanel.ONECLICKALGORITHM:
									frame
											.getMessagePane()
											.append(
													"Click on a vertex to start the "
															+ ((Algorithm) (algwin.algorithmVector
																	.elementAt(loc)))
																	.getName()
															+ " Algorithm.\n");
									break;
								case JeditPanel.TEXTINPUTALGORITHM:
									panel.setEnable(false);
									// System.out.println("panel.getAlgorithm().getName()
									// = "+panel.getAlgorithm().getName());
									new InputString(panel.getAlgorithm()
											.getName(), panel);
									break;
								case JeditPanel.TWOCLICKALGORITHM:
									frame
											.getMessagePane()
											.append(
													"Click on two vertices to start the "
															+ ((Algorithm) (algwin.algorithmVector
																	.elementAt(loc)))
																	.getName()
															+ " Algorithm.\n");
									break;
								case JeditPanel.AUTOMATICALGORITHM:
									Vector animationVector = new Vector();
									panel.backup();
									panel.getAlgorithm().callOwnConstructor(
											panel.getGraph(), null,
											animationVector);
									if (panel.getAlgorithm().succeeded()) {
										Animation animate = new Animation(animationVector, panel, true);
										// E. VandenBerg 2002-Jun-21 animate (parameter 3 is true if we want to animate)
										animate.start();
									}
									panel.repaint();
									panel.setEnable(false);
									break;
								} // switch
							} // if
						} // if
					} // for
				} // else if

				if (s.equals("WindowTileH")) {
				}// Tile Horizontally
				if (s.equals("WindowTileV")) {
				}// Tile Vertically
				if (s.equals("WindowCascade")) {
				}// Cascade

				if (s.equals("HelpIntroduction")) {
				}// Introduction
				if (s.equals("HelpContents")) {
				} // Contents
				if (s.equals("HelpAbout")) {
					new ImageSequenceTimer(panel);
				} // About Jedit...

			} catch (Exception ex) {
				;
			}

		}

		/**
         *
         *  Adds an Image as a background in the JEdit Algorithm Animation Panel
         *
         *
         */
		private Image imageOpen(String fDirectory, String fName) {

			Image newImage = null;
			byte[] byteImage = new byte[63000];

			FileDialog f = new FileDialog(frame, "Load", FileDialog.LOAD);
			f.setDirectory(fDirectory);
			f.setFile(fName);
			f.show();
			String dirname = f.getDirectory();
			String filename = f.getFile();
			if (filename != null) {
				try {

					FileImageInputStream fiips = new FileImageInputStream(new File(dirname + filename));
					FileInputStream fis = new FileInputStream(dirname + filename);

					//ObjectInputStream in = new ObjectInputStream(fis);
					//newImage = (Image) in.readObject();

					fis.read(byteImage);

					//in.close();
					//fiips.close();
					//fis.close();



                    ImageIcon newImIcon = new ImageIcon(byteImage);
                    newImage = newImIcon.getImage();

                    System.out.println("Setting the new Image.." + newImage.toString());

					lastDirectory = dirname;
					lastFileName = filename;

					frame.setTitle(JeditFrame.baseTitle + " - [" + dirname
							+ filename + "]");
				} catch (Exception e1) {
					System.out.println(e1);
					e1.printStackTrace();
				}
			}

			return newImage;

		}

		private JavaGraph graphOpen(String fDirectory, String fName) {

			// System.out.println("fDirectory="+fDirectory+" fName="+fName);

			JavaGraph graph = null;// E. VandenBerg 2002-Jun-06

			// Following added by Jay, July 31,2000
			FileDialog f = new FileDialog(frame, "Load", FileDialog.LOAD);
			f.setDirectory(fDirectory);// E. VandenBerg 2002-Jun-06
			f.setFile(fName);
			f.show();
			String dirname = f.getDirectory();// E. VandenBerg 2002-Jun-06
			String filename = f.getFile();
			if (filename != null) {
				try {
					FileInputStream fis = new FileInputStream(dirname
							+ filename);
					GZIPInputStream gzis = new GZIPInputStream(fis);
					ObjectInputStream in = new ObjectInputStream(gzis);
					graph = (JavaGraph) in.readObject();
					in.close();
					// //System.out.println("You loaded " + filename);
					lastDirectory = dirname;// E. VandenBerg 2002-Jun-06
					lastFileName = filename;// E. VandenBerg 2002-Jun-06
					frame.setTitle(JeditFrame.baseTitle + " - [" + dirname
							+ filename + "]");// E. VandenBerg 2002-Jun-06
				} catch (Exception e1) {
					System.out.println(e1);
				}
			}

			return graph;// E. VandenBerg 2002-Jun-06

			// Modified to use JFileChooser 2002-Jun-07 E. VandenBerg
			// //System.out.println("Instantiating JeditFileFilter...");
			// JeditFileFilter filter = new JeditFileFilter();
			// filter.addExtension("gph");
			// filter.setDescription("Jedit Graphs (*.gph)");
			// //System.out.println("Instantiating JFileChooser...");
			// JFileChooser chooser = new JFileChooser(fDirectory+fName);
			// //System.out.println("Setting chooser file filter...");
			// chooser.setFileFilter(filter);
			// //System.out.println("Showing open dialog...");
			// int returnVal = chooser.showOpenDialog(frame);
			// //System.out.println("returnVal = "+(new
			// Integer(returnVal)).toString());
			// if (returnVal == JFileChooser.APPROVE_OPTION) {
			// String dirname = chooser.getCurrentDirectory().toString();//E.
			// VandenBerg 2002-Jun-06
			// String filename = chooser.getName();
			// //System.out.println("dirname="+dirname+" filename="+filename);
			// try {
			// FileInputStream fis = new FileInputStream(dirname+filename);
			// GZIPInputStream gzis = new GZIPInputStream(fis);
			// ObjectInputStream in = new ObjectInputStream(gzis);
			// graph = (JavaGraph)in.readObject();
			// in.close();
			// //System.out.println("You loaded " + filename);
			// lastDirectory=dirname;//E. VandenBerg 2002-Jun-06
			// lastFileName=filename;//E. VandenBerg 2002-Jun-06
			// frame.setTitle(JeditFrame.baseTitle+" -
			// ["+dirname+filename+"]");//E. VandenBerg 2002-Jun-06
			// }
			// catch (Exception e1) {//System.out.println(e1);}
			// }

		}

		private void graphSaveAs(JavaGraph graph, String fDirectory,
				String fName) {
			FileDialog f = new FileDialog(frame, "Save", FileDialog.SAVE);
			f.setDirectory(fDirectory);// E. VandenBerg 2002-Jun-06
			f.setFile(fName);
			f.show();
			String dirname = f.getDirectory();// E. VandenBerg 2002-Jun-06
			String filename = f.getFile();
			// System.out.println("filename="+filename);
			if (filename != null) {
				graphSave(graph, dirname, filename);// E. VandenBerg 2002-Jun-06
													// moved to method
				frame.setTitle(JeditFrame.baseTitle + " - [" + dirname
						+ filename + "]");// E. VandenBerg 2002-Jun-06
			}
			lastDirectory = dirname;// E. VandenBerg 2002-Jun-06
			lastFileName = filename;// E. VandenBerg 2002-Jun-06
		} // end of "Save as" added by Dr. Bagga

		private void graphSave(JavaGraph graph, String fDirectory, String fName) {
			// System.out.println("graphSave");
			try {
				// System.out.println("1");
				FileOutputStream fos = new FileOutputStream(fDirectory + fName);
				// System.out.println("2");
				GZIPOutputStream gzos = new GZIPOutputStream(fos);
				// System.out.println("3");
				ObjectOutputStream out = new ObjectOutputStream(gzos);
				// System.out.println("4");
				if (graph == null)
					System.out.println("graph is null");

				out.writeObject(graph);
				// System.out.println("5");
				out.flush();
				// System.out.println("6");
				out.close();
				System.out.println("You saved " + fName);
			} catch (Exception e1) {// System.out.println(e1);
			}
		}

	} // public class JeditAction

	/**
	 * Creates a window asking the user for a Yes or No response. The user
	 * responds by clicking the appropriate button, and a predetermined action
	 * is carried out. Used in Jedit to obtain confirmation before erasing a
	 * graph.
	 *
	 * @author Aaron Nall
	 * @author Vellanki Kiran
	 * @since 1 July 1998
	 * @version 11 Nov 1999
	 * @see javax.swing.JFrame
	 * @see java.awt.event.ActionListener
	 * @see java.awt.event.MouseListener
	 * @see java.awt.event.WindowListener
	 */
	class YesNo extends JFrame implements ActionListener, MouseListener,
			WindowListener, Serializable {
		/**
		 * A flag indicating that this YesNo will clear the graph if the user
		 * responds with a "Yes".
		 */
		public final static int CLEAR = 0;

		/**
		 * A flag indicating that no action is required when the user responds
		 * to this YesNo's message.
		 */
		public final static int NOTHING = 1;

		private Vector message;

		private JButton yes, no;

		private Thread thread;

		private JeditPanel panel;

		private int action;

		private boolean active = false;

	/**	Constructs a new YesNo.
		@param	Caption 	The title of the window.
		@param	yup 	The label for the "Yes" button.
		@param	nope  	The label for the "No" button.
		@param	whattoSay 	A Vector holding Strings that make up the question being asked.
		@param	newPanel 	The <a href = JeditPanel.html>JeditPanel</a> that will receive
		the action of this YesNo.
		@param	actionToDo 	the	flag determining the action of this YesNo.  Valid options are
		<a href = #CLEAR>CLEAR</a> and <a href = #NOTHING>NOTHING</a>.
	*/
	public YesNo (	String caption,
					String yup,
					String nope,
					Vector whatToSay,
					JeditPanel newPanel,
					int actionToDo) {

		super(caption);
		setBackground(Color.lightGray);
		action = actionToDo;
		panel = newPanel;
		Font buttonFont, messageFont;
		messageFont = new Font("Serif", Font.BOLD, 24);
		buttonFont = new Font("Serif", Font.PLAIN, 20);
		FontMetrics buttonMetrics = getFontMetrics(buttonFont);
		FontMetrics messageMetrics = getFontMetrics(messageFont);
		yes = new JButton(yup);
		no = new JButton(nope);
		int maxWidth = 0;
		message = new Vector();
		while (!whatToSay.isEmpty()) {
			JLabel label = new JLabel((String)(whatToSay.elementAt(0)), JLabel.CENTER);
			label.setFont(messageFont);
			message.addElement(label);
			int width = messageMetrics.stringWidth((String)(whatToSay.elementAt(0)));
			if (width > maxWidth)
				maxWidth = width;
			whatToSay.removeElementAt(0);
		}
		yes.setFont(buttonFont);
		no.setFont(buttonFont);
		setSize(maxWidth + 30, buttonMetrics.getHeight() + 95 + message.size()*(messageMetrics.getHeight()));
		setResizable(false);
		getContentPane().setLayout(new GridLayout(message.size() +1, 1));
       /* Add the string taking into account the size     */
		for (int i = 0; i < message.size(); i++) {
			JLabel label = (JLabel)message.elementAt(i);
			getContentPane().add(label);
			label.setSize(getSize().width, label.getSize().height);
		}
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 100,5));
		buttonPanel.add(yes);
		buttonPanel.add(no);
		buttonPanel.setBackground(Color.lightGray);
		getContentPane().add(buttonPanel);
		yes.addActionListener(this);
		no.addActionListener(this);
		addMouseListener(this);
		addWindowListener(this);
	}

	/** Acts as directed by the particular Button that has been clicked on.
		@param	e	The ActionEvent.
	*/
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == yes) {
			panel.backup();
			switch (action)
			{
				case CLEAR:
					panel.getGraph().removeAllVertices();
					panel.getGraph().setGraphType(JavaGraph.GRAPH);
					panel.repaint();
					break;
				case NOTHING:
					dispose();
					break;
			}
		}
		else {
		}
		panel.setEnable(true);
		//setVisible(false);
		dispose();
	}

	/**
		@param	e	The MouseEvent..
	*/
	public void mouseEntered(MouseEvent e) {
		active = true;
	}

	/**
		@param	e	The WindowEvent...
	*/
	public void windowIconified(WindowEvent e) {
		if (active)
			dispose();
	}

	/**
		@param	e	The WindowEvent...
	*/
	public void windowClosing(WindowEvent e) {
		dispose();
	}

	/** Not Implemented. */
	public void windowActivated(WindowEvent e) {}

	/** Not Implemented. */
	public void windowDeactivated(WindowEvent e) {}

	/** Not Implemented. */
	public void windowDeiconified(WindowEvent e) {}

	/** Not Implemented. */
	public void windowClosed(WindowEvent e) {}

	/** Not Implemented. */
	public void windowOpened(WindowEvent e) {}

	/** Not Implemented. */
	public void mouseExited(MouseEvent e) {}

	/** Not Implemented. */
	public void mousePressed(MouseEvent e) {}

	/** Not Implemented. */
	public void mouseReleased(MouseEvent e) {}

	/** Not Implemented. */
	public void mouseClicked(MouseEvent e) {}


	/*public static void main(String[] args) {
		Vector newstuff = new Vector();
		newstuff.addElement(new String("Duh"));
		newstuff.addElement(new String("Does this work or not?  Whatever."));
		YesNo message = new YesNo("Testing", "OK", "NO!", newstuff,new JeditPanel(null,null),1);
		message.setVisible(true);
	}*/
}//class YesNo
}